#include <stdio.h>
#include <ctype.h>

static char *verify();

main(argc, argv)
int argc;
char *argv[];
{
  int c, prev_c, count, length, i;
  char s[256], prev_s[256], *p, *q, *r, *t, *strchr(), *strcat();
  FILE *fopen(), *mapfile, *collectfile, *psectfile, *xfrfile;
  char line[256], library[32];

  if (argc < 1) {
     printf("Usage: Extract library\n");
     exit();
  }

  strcpy(library,argv[1]);

  strcpy(s,library);
  strcat(s,".map");
  if ( (mapfile = fopen(s,"r")) == NULL) {
     printf("%s does not exist\n",argv[1]);
     exit();
  }
  strcpy(s,library);
  strcat(s,"_xfr.mar");
  if ( (xfrfile = fopen(s,"w")) == NULL) {
     printf("Cannot open output file\n");
     exit();
  }
  if ( (collectfile = fopen("collectopt.opt","a")) == NULL) {
     printf("Cannot open output file\n");
     exit();
  }
  if ( (psectfile = fopen("isode:[utils]psectopt.opt","a")) == NULL) {
     printf("Cannot open output file\n");
     exit();
  }

   fprintf(xfrfile,".title %s_xfr\n",library);
   fprintf(xfrfile,".ident /v1.0/\n");
   fprintf(xfrfile,".psect $$%s_xfrvectors,exe,nowrt\n\n",library);

   while (fgets(line,256,mapfile) != NULL) {
      for(p = line; *p != '\0';p++) if (isupper(*p)) *p = tolower(*p);
      if ( verify(line,"  shr") && verify(line,"  wrt") ) {
         sprintf(s,"%.*s",strcspn(line," "),line);
         if (strcmp(s,prev_s) != 0) {
            fprintf(psectfile,"psect_attr=%s,noshr\n",s);
            fprintf(collectfile,"collect=%s_vars,%s\n",library,s);
         }
         strcpy(prev_s,s);
      }
      if ( (t = verify(line,"  r-")) ) {
         sprintf(s,"%.*s",strcspn(t+4," \t\n"),t+4);
         if (strcmp(s,"c$v_ctypedefs") != 0) {
            fprintf(xfrfile,".transfer %s\n",s);
            fprintf(xfrfile,".mask %s\n",s);
            fprintf(xfrfile,"jmp l^%s+2\n\n",s);
         }
      }
   }
   fprintf(xfrfile,".end\n");
   fclose(xfrfile);
   fprintf(psectfile,"\n");
   fclose(psectfile);
   fclose(collectfile);
   exit();
}

static char *verify(s,t)
char *s, *t;
{
   int i;
   i = strlen(t);
   while (*s != NULL) {
      if (strncmp(s,t,i) == 0) return(s);
      s++;
   }
   return(NULL);
 }
