#include <stdio.h>
#include <errno.h>
#define TRUE 1
#define FALSE 0
/*#define MAX_LENGTH 31*/
#define MAX_LENGTH 23
#define BUFFER 512

char *x[2000];
int y[2000];
char z[2000];
int x_count;
int changed;
char * malloc();
char eol[2] = "\n";

main(argc, argv)
int argc;
char *argv[];
{
  int in_identifier, in_comment, in_quotes, in_preprocessor;
  int c, prev_c, count, length, i;
  char id[1024], s[BUFFER], buffer[BUFFER], *p, *q, *r, *strchr(), newbuff[BUFFER];
  char *strchr();
  FILE *fopen(), *infile, *outfile, *namesfile, *deffile;

  if (argc < 3) {
     printf("Usage: Preprocess infile outfile [longnamesfile]\n");
     exit();
  }

  if ( (infile = fopen(argv[1],"r")) == NULL) {
     printf("%s does not exist\n",argv[1]);
     exit();
  }
  if ( (outfile = fopen(argv[2],"w")) == NULL) {
     printf("Cannot open output file errno=%d\n",errno);
     exit();
  }
  x_count = -1;
  if ((argc == 4) && (namesfile = fopen(argv[3],"r")) != NULL) {
     while (fgets(s, BUFFER, namesfile) != NULL) {
        i = strlen(s) - 1;
        s[i] = '\0';
        x[++x_count] = malloc(i+4);
        strcpy(x[x_count],s);
        y[x_count] = i;
        z[x_count] = s[i-1];
     }
     fclose(namesfile);
  }
  changed = 0;
  prev_c = '\n';
  length = 1;
  in_identifier = FALSE;
  in_comment = FALSE;
  in_quotes = FALSE;
  in_preprocessor = FALSE;
  if (argv[2][strlen(argv[2])-1] == 'c') { /* add to beginning of .c files */
     fprintf(outfile,"#include <fiddle.h>\n");
  }
  p = buffer;
  memset(buffer,0,BUFFER);
  c = getc(infile);
  while (c != EOF) {
     length = (int)(p-buffer);
     if (prev_c == '\n') in_preprocessor = (c == '#');
     if ( (length > 160) && ( ! in_preprocessor) &&( ! in_quotes) &&
      (strchr("; \t)(",prev_c) != NULL)) {
        fputs(buffer,outfile);
        fputs(eol,outfile);
        memset(buffer,0,BUFFER);
	p = buffer;
     }
     if ((length > 200) && (in_preprocessor || in_quotes) && (prev_c != '\\')) {
        *p++ = '\\';
        fputs(buffer,outfile);
        fputs(eol,outfile);
        memset(buffer,0,BUFFER);
	p = buffer;
     }
     if (in_quotes) {
        if ((c == '"') && (prev_c != '\\')) in_quotes = FALSE;
        *p++ = c;
     }
     else if (in_comment) {
        if ((c == '/') && (prev_c == '*')) in_comment = FALSE;
        *p++ = c;
     }
     else if ( ! in_identifier) {
        if ( ((c >= 'A') && (c <= 'Z')) || ((c >= 'a') && (c <= 'z'))
             || (c == '_') ) {
           in_identifier = TRUE;
           count = 0;
           id[count] = c;
	}
        else {
           if ((c == '"') && (prev_c != '\\') && (prev_c != '\'')) in_quotes = TRUE;
           if ((c=='*') && (prev_c == '/')) in_comment = TRUE;
           *p++ = c;
	}
     }
     else {
        if ( ((c >= 'A') && (c <= 'Z')) || ((c >= 'a') && (c <= 'z'))
             || ((c >= '0') && (c <= '9')) || (c == '_') ) {
           id[++count] = c;
        }
        else {
           id[++count] = 0;
           if (count < MAX_LENGTH) {
              strcpy(p,id);
              i = strlen(id);
              p += i;
	   }
           else {
              sprintf(p,"%.*s%04d",MAX_LENGTH-4,id,xlate(id));
              p += MAX_LENGTH;
	      if (argc != 4) printf("Warning - longnames but no file given\n");
	   }
           *p++ = c;
           in_identifier = FALSE;
	}
     }
     if (c == '\n') {
        if (buffer[0] == '#') {
           for(q=buffer+1;(*q == ' ') || (*q == '\t');q++);/*skip white space*/
           if (strncmp(q,"include",7) == 0) {
	      p = strchr(buffer,'\"');  /* forget about <...> */
	      if (p != NULL) {
	         q = strchr(p+1,'\"'); /* remove any comments */
	         q++;
	         *q++ = '\n';
	         *q++ = '\0';
	         if ((strchr(p,'/') != NULL) && (*(p+1) != '.')){ /* only fix "xx/yy" */
	            strcpy(newbuff,"#include \"isode:[h.");
	            q = newbuff+19;
		    p++;
	            r = p;
	            while ( (p = strchr(p,'/')) != NULL) {
		       if (strncmp(r,"../",3) == 0) {
		          *q++ = '-';
		          *q++ = '.';
		       }
		       else if (strncmp(r,"./",2) == 0) {
		       }
		       else {
		          for(;r != p;) *q++ = *r++;
		          *q++ = '.';
	               }
		       p++;
		       r = p;
		    }
		    q--;       /*overwrite last . with a ]*/
		    if (*q == '[') q++; /* but not if of form "./xx"*/
		    *q++ = ']';
		    strcpy(q,r);
	            strcpy(buffer,newbuff);
	         }
	      }
	   }
        }
        fputs(buffer,outfile);
        memset(buffer,0,BUFFER);
	p = buffer;
     }
     prev_c = c;
     c = getc(infile);
  }
  fclose(infile);
  fclose(outfile);
  if (changed == 0) exit();
  if (argc == 4) {
     delete(argv[3]);
     namesfile = fopen(argv[3],"w");
     for(i=0;i<=x_count;i++) {fputs(x[i],namesfile);fputs(eol,namesfile);}
     fclose(namesfile);
  }
  exit();
}

int xlate(s)
char *s;
{
  int i, l;
  char c;
  l = strlen(s);
  c = s[l-1];
  for(i=0;i<=x_count;i++) {
     if ((y[i] == l) && (z[i] == c) && (strcmp(s,x[i]) == 0)) return(i);
  }
  x[++x_count] = malloc(l+4);
  strcpy(x[x_count],s);
  y[x_count] = l;
  z[x_count] = c;
  changed = 1;
  return(x_count);
}

